const superagent = require("superagent");
const app = require('./src/express');
const logger = require("./src/logging");
const {setup, start} = require('./src/register');
const environment = require('./src/environment');

app.helper = require("./src/helper");
app.logger = logger;

(async () => {
    await start(
        environment.controller_url,
        environment.webserver_port,
        environment.current_service
    );
    await setup(
        environment.controller_url,
        environment.webserver_port,
        environment.current_service
    );
})();

let job_id = null;

app.registerJob = async (cb) => {
    app.post('/job', async (req, res)=> {

        job_id = req.body.id;

        await cb(req.body.id, req.body.param);

        res.send({
            message:'ok'
        });

    });
}

app.sendUpdate = async (msg) => {
    superagent.put(environment.controller_url+ '/jobs/update')
        .send({
            "result": msg,
            "id": job_id
        })
        .set('Accept', 'application/json')
        .then((r) => {
            console.log('Update Job ' + job_id + ' .');
        }).catch(logger.error);
}

app.sendEnd = async (msg) => {
    superagent.post(environment.controller_url+ '/jobs/success')
        .send({
            "result": msg,
            "id": job_id
        })
        .set('Accept', 'application/json')
        .then(() => {
            logger.info('Send Job ' + job_id + ' back.');
        }).catch(logger.error);
}

module.exports = app;
